Classes | Namespaces | Macros | Typedefs | Functions
libvisio_utils.h File Reference
`#include <memory>`
`#include <boost/cstdint.hpp>`
`#include "VSDTypes.h"`
`#include <librevenge/librevenge.h>`
`#include <librevenge-stream/librevenge-stream.h>`
`#include <unicode/utypes.h>`

Go to the source code of this file.

## Classes
struct | libvisio::VSDDummyDeleter
class | libvisio::EndOfStreamException
class | libvisio::XmlParserException
class | libvisio::GenericException

## Namespaces
| libvisio

## Macros
#define | VSD_EPSILON 1E-6
#define | VSD_ALMOST_ZERO(m) (fabs(m) <= VSD_EPSILON)
#define | VSD_APPROX_EQUAL(x, y) VSD_ALMOST_ZERO((x) - (y))
#define | VSD_ATTRIBUTE_PRINTF(fmt, arg)
#define | VSD_DEBUG_MSG(M)
#define | VSD_DEBUG(M)
#define | VSD_NUM_ELEMENTS(array) (sizeof(array)/sizeof((array)[0]))

## Typedefs
typedef std::shared_ptr< librevenge::RVNGInputStream > | libvisio::RVNGInputStreamPtr_t

## Functions
template<typename T , typename... Args>
std::unique_ptr< T > | libvisio::make_unique (Args &&... args)
template<typename T >
std::unique_ptr< T > | libvisio::clone (const std::unique_ptr< T > &other)
uint8_t | libvisio::readU8 (librevenge::RVNGInputStream *input)
uint16_t | libvisio::readU16 (librevenge::RVNGInputStream *input)
int16_t | libvisio::readS16 (librevenge::RVNGInputStream *input)
uint32_t | libvisio::readU32 (librevenge::RVNGInputStream *input)
int32_t | libvisio::readS32 (librevenge::RVNGInputStream *input)
uint64_t | libvisio::readU64 (librevenge::RVNGInputStream *input)
double | libvisio::readDouble (librevenge::RVNGInputStream *input)
const librevenge::RVNGString | libvisio::getColourString (const Colour &c)
unsigned long | libvisio::getRemainingLength (librevenge::RVNGInputStream *input)
void | libvisio::appendUCS4 (librevenge::RVNGString &text, UChar32 ucs4Character)
void | libvisio::debugPrint (const char *format,...) VSD_ATTRIBUTE_PRINTF(1

## Macro Definition Documentation

## ◆ VSD_ALMOST_ZERO

#define VSD_ALMOST_ZERO | ( |  | m | ) | (fabs(m) <= VSD_EPSILON)

## ◆ VSD_APPROX_EQUAL

#define VSD_APPROX_EQUAL | ( |  | x,
|  |  | y
| ) |  | VSD_ALMOST_ZERO((x) - (y))

## ◆ VSD_ATTRIBUTE_PRINTF

#define VSD_ATTRIBUTE_PRINTF | ( |  | fmt,
|  |  | arg
| ) |  |

## ◆ VSD_DEBUG

#define VSD_DEBUG | ( |  | M | ) |

## ◆ VSD_DEBUG_MSG

#define VSD_DEBUG_MSG | ( |  | M | ) |

## ◆ VSD_EPSILON

#define VSD_EPSILON 1E-6

## ◆ VSD_NUM_ELEMENTS

#define VSD_NUM_ELEMENTS | ( |  | array | ) | (sizeof(array)/sizeof((array)[0]))